//  The facet synchronizer is a component of the bit synchronizer 
//  which takes the received signal and the local clock as the 
//  input and synchronizes to the incoming signal to give the 
//  corrected clock. it is loop and if the reset is enabled then 
//  the synchronization starts again with the initial clock 

use signalTypes;

facet synchronizer( inSignal :: in signal;clock :: inout squareSignal;reset
::in bit ) is

	initialClock::squareSignal;
	syncronize(inputSignal::signal;oldClock::squareSignal)::squareSignal;

begin state_based
	
	sync: if %reset 
		then clock' = syncronize(inSignal,initialClock)
		else clock' = syncronize(inSignal,clock)
	      endif;

end synchronizer;
	
